// Include --> Trade for more details
#include  <Trade/Trade.mqh>

// class CTrade from Trade code 
CTrade trade;

//--- input parameters
//input ENUM_POSITION_TYPE   InpPosType  = POSITION_TYPE_BUY; 
//input ENUM_POSITION_TYPE   InpPosType  = POSITION_TYPE_SELL; 

int OnInit(){//initialization




   return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason){//untick function

}


void OnTick(){// whenever there is a tick in a chart 

   // not to print the condition met very time, but only when the signal changes
   static datetime timestamp;
   datetime time = iTime(_Symbol, PERIOD_CURRENT,0);
   if(timestamp != time){
      timestamp = time;   

      static int handleSlowMA = iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_SMA,PRICE_OPEN);
      double slowMaArray[];
      CopyBuffer(handleSlowMA,0,1,2,slowMaArray);// store the value of MA // we will start from the last candle index 1 and one before last;
      ArraySetAsSeries(slowMaArray,true);
   
      static int handleFastMA = iMA(_Symbol,PERIOD_CURRENT,5,0,MODE_SMA,PRICE_OPEN);
      double fastMaArray[];
      CopyBuffer(handleFastMA,0,1,2,fastMaArray);// store the value of MA // we will start from the last candle index 1 and one before last;
      ArraySetAsSeries(fastMaArray,true);
 
   
           
     static int handlePSAR = iSAR(_Symbol, PERIOD_CURRENT, 0.02, 0.2); // so far the standard values for step and max 
      double psar[];
      CopyBuffer(handlePSAR,0,1,2,psar);
      ArraySetAsSeries(psar,true);
      double lastsv = NormalizeDouble(psar[1],5); // 5 decimals
      
      
      MqlRates PriceArray[];  // store the price values
      ArraySetAsSeries(PriceArray,true);
      int Data = CopyRates(_Symbol, _Period, 0, 3, PriceArray);
      
      
      int ticket = PositionGetTicket(0);
      int direction = PositionGetInteger(POSITION_TYPE);  // assuming only one open position
      
   
      /// buy signal
      if (fastMaArray[0] > slowMaArray[0] && lastsv <  PriceArray[1].low && direction !=  POSITION_TYPE_BUY){ // check whats's the direction of the current position not to duplicate
      
         // if (fastMaArray[0] > slowMaArray[0]&& fastMaArray[1] < slowMaArray[1] && lastsv <  PriceArray[1].low){
         Print("fast MA crossing above slow MA");
         double ask = SymbolInfoDouble(_Symbol, SYMBOL_ASK); // get the ask price
         double sl = ask - 25000*SymbolInfoDouble(_Symbol,SYMBOL_POINT); // 25 kopeks  s/l
         double tp = ask + 100000*SymbolInfoDouble(_Symbol,SYMBOL_POINT); // 80 kopeks
         
         // 0.01 lots; 
         trade.Buy(1, _Symbol,ask,sl,tp,"this is a buy");
      }
   
      /// sell signal 
      if (fastMaArray[0] < slowMaArray[0] && lastsv > PriceArray[1].high && direction !=  POSITION_TYPE_SELL){
      
      //  if (fastMaArray[0] < slowMaArray[0]&& fastMaArray[1] > slowMaArray[1] && lastsv > PriceArray[1].high){
         Print("fast MA crossing below slow MA");
         double bid = SymbolInfoDouble(_Symbol, SYMBOL_ASK); // get the bid price
         double tp = bid - 100000*SymbolInfoDouble(_Symbol,SYMBOL_POINT); // 80 kopeks
         double sl = bid + 25000*SymbolInfoDouble(_Symbol,SYMBOL_POINT); // 25 kopeks  s/l
         
         // 0.01 lots; 
         trade.Sell(1, _Symbol,bid,sl,tp,"this is a sell");
         
      }
      
     //       bool m_need_close_buys ; // define global variable for using multiple times
     // bool m_need_close_sells ;

     //if(rsi[0] > 80){
     //    m_need_close_buys=true;  
     //    return;
     // }
  
     // if(rsi[0] < 20){
     //    m_need_close_sells=true;
     //    return;
     // }
         
      
      //if(m_need_close_buys || m_need_close_sells){
  
      //---
      //if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY && rsi[0] > 70 && rsi[1] <= 70){
      //  if(rsi[0] > 70 && rsi[1] <= 70){
        
      //   CloseAllBuyPos(); 
         //int ticket = PositionGetTicket(1);
         //trade.PositionClose(ticket);
      //   Comment("Close open buys");
       //}
      //---
       //if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL && rsi[0] < 30 && rsi[1] >= 30){
      //   if(rsi[0] < 30 && rsi[1] >= 30){
       //     CloseAllSellsPos();
         //int ticket = PositionGetTicket(1);
         //trade.PositionClose(ticket);
      //      Comment("Close open sells");
           // }

       // }
 
      Comment("\nSlowMaArray[0]: ",fastMaArray[0],
            "\nSlowMaArray[1]: ",fastMaArray[1],
            "\nSlowMaArray[0]: ",slowMaArray[0],
            "\nSlowMaArray[1]: ",slowMaArray[1]);
   }
   
   static int handlersi = iRSI(_Symbol, PERIOD_CURRENT, 10, PRICE_OPEN);
      double rsi[];
      CopyBuffer(handlersi,0,1,2,rsi);// store the value of RSI
      ArraySetAsSeries(rsi,true);
   
    static int handleSlowMA = iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_SMA,PRICE_OPEN);
      double slowMaArray[];
      CopyBuffer(handleSlowMA,0,1,2,slowMaArray);// store the value of MA // we will start from the last candle index 1 and one before last;
      ArraySetAsSeries(slowMaArray,true);
   
   
   
     static int handleFastMA = iMA(_Symbol,PERIOD_CURRENT,5,0,MODE_SMA,PRICE_OPEN);
      double fastMaArray[];
      CopyBuffer(handleFastMA,0,1,2,fastMaArray);// store the value of MA // we will start from the last candle index 1 and one before last;
      ArraySetAsSeries(fastMaArray,true);
      
     static int handlePSAR = iSAR(_Symbol, PERIOD_CURRENT, 0.02, 0.2); // so far the standard values for step and max 
      double psar[];
      CopyBuffer(handlePSAR,0,1,2,psar);
      ArraySetAsSeries(psar,true);
      double lastsv = NormalizeDouble(psar[1],5); // 5 decimals
      
      
      MqlRates PriceArray[];  // store the price values
      ArraySetAsSeries(PriceArray,true);
      int Data = CopyRates(_Symbol, _Period, 0, 3, PriceArray);
      
      
   //if((rsi[0] >= 80 && rsi[1] < 80 )){
   
      
   if(fastMaArray[0] < slowMaArray[0] && lastsv > PriceArray[1].high){
   //if(fastMaArray[0] < slowMaArray[0] && fastMaArray[1] > slowMaArray[1] && lastsv > PriceArray[1].high){
      CloseAllBuyPos(); 
      //int ticket = PositionGetTicket(1);
      //trade.PositionClose(ticket);
     
      //---
       //if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL && rsi[0] < 30 && rsi[1] >= 30){
       
   }
   //if((rsi[0] <= 20 && rsi[1] > 20)){
   
   if(fastMaArray[0] > slowMaArray[0] && lastsv < PriceArray[1].low){
   //if(fastMaArray[0] > slowMaArray[0] && fastMaArray[1] < slowMaArray[1] && lastsv < PriceArray[1].low){
  
   
      CloseAllSellsPos();
         
      //int ticket = PositionGetTicket(1);
      //trade.PositionClose(ticket);
     
   }
   
}   

/// 
void CloseAllBuyPos(){


   for(int i=PositionsTotal()-1; i>= 0; i--){
      int ticket =PositionGetTicket(i);
      int direction =PositionGetInteger(POSITION_TYPE);
      if (direction == POSITION_TYPE_BUY){
      
          trade.PositionClose(ticket);
      
      }
      
   
      } // end loop 

}// end functionn 

void CloseAllSellsPos(){


   for(int i=PositionsTotal()-1; i>= 0; i--){
      int ticket =PositionGetTicket(i);
      int direction =PositionGetInteger(POSITION_TYPE);
      if (direction == POSITION_TYPE_SELL){
      
          trade.PositionClose(ticket);
      }
      
 
   
      } // end loop 

}// end functionn 


